﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Data;

namespace App
{
    /// <summary>
    /// Formulář pro úpravu osoby (Person)
    /// </summary>
    public partial class PersonEdit : Form
    {
        private ListBox list;
        private Person p;

        /// <summary>
        /// Načte data vybrané osoby do formulářových prvků
        /// </summary>
        /// <param name="list">ListBox</param>
        public PersonEdit(ListBox list)
        {
            this.list = list;
            InitializeComponent();

            personCtrl1.TextBoxId.ReadOnly = true;
            this.p = list.SelectedItem as Person;

            personCtrl1.TextBoxName.Text = p.Name;
            personCtrl1.TextBoxLastName.Text = p.Surname;
            personCtrl1.TextBoxId.Text = p.CompanyId.ToString();
            personCtrl1.TextBoxBank.Text = p.BankAccount;
            if (p.TaxId == null)
                personCtrl1.TextBoxTaxId.Text = "Není plátce DPH";
            else
                personCtrl1.TextBoxTaxId.Text = p.TaxId;
            personCtrl1.TextBoxStreet.Text = p.Street;
            personCtrl1.TextBoxStreetNr.Text = p.NR.ToString();
            personCtrl1.TextBoxPostCode.Text = p.PostCode.ToString();
            //PersonForm.DateTimePicker1.Text = (list.SelectedItem as Person).Datum;
        }

        /// <summary>
        /// Uloží pozměněné informace o osobě
        /// </summary>
        /// <param name="sender"object></param>
        /// <param name="e">EventArgs</param>
        private void personOk_Click(object sender, EventArgs e)
        {
            p.Name = personCtrl1.TextBoxName.Text;
            p.Surname = personCtrl1.TextBoxLastName.Text;
            p.CompanyId = int.Parse(personCtrl1.TextBoxId.Text);
            p.BankAccount = personCtrl1.TextBoxBank.Text;
            p.TaxId = personCtrl1.TextBoxTaxId.Text;
            p.Street = personCtrl1.TextBoxStreet.Text;
            p.NR = int.Parse(personCtrl1.TextBoxStreetNr.Text);
            p.PostCode = int.Parse(personCtrl1.TextBoxPostCode.Text);

            Close();
        }

        /// <summary>
        /// Uzavře formulář bez uložení dat, klávesová zkratka ESC.
        /// </summary>
        /// <param name="sender">object</param>
        /// <param name="e">EventArgs</param>
        private void personCancel_Click(object sender, EventArgs e)
        {
            Close();
        }

        /// <summary>
        /// Klávesové zkratky pro práci s formulářem.
        /// ENTER = uložit
        /// ESC = zavřít
        /// </summary>
        /// <param name="sender">object</param>
        /// <param name="e">KeyEventArgs</param>
        public void KeyUpEvent(object sender, KeyEventArgs e) //aby to fungovalo musí se u okna zapnout KeyPreview!!!
        {
            switch (e.KeyCode)
            {
                case Keys.Enter:
                    personOk.PerformClick();
                    break;

                case Keys.Escape:
                    personCancel.PerformClick();
                    break;

                default:
                    break;
            }
        }

    }
}
